package onnxtest

import "github.com/owulveryck/onnx-go/backend/testbackend"

func init() {
	// Register all the test cases

	testbackend.Register("Abs", "TestAbs", NewTestAbs)
	testbackend.Register("Acos", "TestAcos", NewTestAcos)
	testbackend.Register("Acos", "TestAcosExample", NewTestAcosExample)
	testbackend.Register("Acosh", "TestAcosh", NewTestAcosh)
	testbackend.Register("Acosh", "TestAcoshExample", NewTestAcoshExample)
	testbackend.Register("Add", "TestAdd", NewTestAdd)
	testbackend.Register("Add", "TestAddBcast", NewTestAddBcast)
	testbackend.Register("ArgMax", "TestArgmaxDefaultAxisExample", NewTestArgmaxDefaultAxisExample)
	testbackend.Register("ArgMax", "TestArgmaxDefaultAxisRandom", NewTestArgmaxDefaultAxisRandom)
	testbackend.Register("ArgMax", "TestArgmaxKeepdimsExample", NewTestArgmaxKeepdimsExample)
	testbackend.Register("ArgMax", "TestArgmaxKeepdimsRandom", NewTestArgmaxKeepdimsRandom)
	testbackend.Register("ArgMax", "TestArgmaxNoKeepdimsExample", NewTestArgmaxNoKeepdimsExample)
	testbackend.Register("ArgMax", "TestArgmaxNoKeepdimsRandom", NewTestArgmaxNoKeepdimsRandom)
	testbackend.Register("ArgMin", "TestArgminDefaultAxisExample", NewTestArgminDefaultAxisExample)
	testbackend.Register("ArgMin", "TestArgminDefaultAxisRandom", NewTestArgminDefaultAxisRandom)
	testbackend.Register("ArgMin", "TestArgminKeepdimsExample", NewTestArgminKeepdimsExample)
	testbackend.Register("ArgMin", "TestArgminKeepdimsRandom", NewTestArgminKeepdimsRandom)
	testbackend.Register("ArgMin", "TestArgminNoKeepdimsExample", NewTestArgminNoKeepdimsExample)
	testbackend.Register("ArgMin", "TestArgminNoKeepdimsRandom", NewTestArgminNoKeepdimsRandom)
	testbackend.Register("Asin", "TestAsin", NewTestAsin)
	testbackend.Register("Asin", "TestAsinExample", NewTestAsinExample)
	testbackend.Register("Asinh", "TestAsinh", NewTestAsinh)
	testbackend.Register("Asinh", "TestAsinhExample", NewTestAsinhExample)
	testbackend.Register("Atan", "TestAtan", NewTestAtan)
	testbackend.Register("Atan", "TestAtanExample", NewTestAtanExample)
	testbackend.Register("Atanh", "TestAtanh", NewTestAtanh)
	testbackend.Register("Atanh", "TestAtanhExample", NewTestAtanhExample)
	testbackend.Register("AveragePool", "TestAveragepool1dDefault", NewTestAveragepool1dDefault)
	testbackend.Register("AveragePool", "TestAveragepool2dCeil", NewTestAveragepool2dCeil)
	testbackend.Register("AveragePool", "TestAveragepool2dDefault", NewTestAveragepool2dDefault)
	testbackend.Register("AveragePool", "TestAveragepool2dPads", NewTestAveragepool2dPads)
	testbackend.Register("AveragePool", "TestAveragepool2dPadsCountIncludePad", NewTestAveragepool2dPadsCountIncludePad)
	testbackend.Register("AveragePool", "TestAveragepool2dPrecomputedPads", NewTestAveragepool2dPrecomputedPads)
	testbackend.Register("AveragePool", "TestAveragepool2dPrecomputedPadsCountIncludePad", NewTestAveragepool2dPrecomputedPadsCountIncludePad)
	testbackend.Register("AveragePool", "TestAveragepool2dPrecomputedSameUpper", NewTestAveragepool2dPrecomputedSameUpper)
	testbackend.Register("AveragePool", "TestAveragepool2dPrecomputedStrides", NewTestAveragepool2dPrecomputedStrides)
	testbackend.Register("AveragePool", "TestAveragepool2dSameLower", NewTestAveragepool2dSameLower)
	testbackend.Register("AveragePool", "TestAveragepool2dSameUpper", NewTestAveragepool2dSameUpper)
	testbackend.Register("AveragePool", "TestAveragepool2dStrides", NewTestAveragepool2dStrides)
	testbackend.Register("AveragePool", "TestAveragepool3dDefault", NewTestAveragepool3dDefault)
	testbackend.Register("Conv", "TestBasicConvWithPadding", NewTestBasicConvWithPadding)
	testbackend.Register("Conv", "TestBasicConvWithoutPadding", NewTestBasicConvWithoutPadding)
	testbackend.Register("BatchNormalization", "TestBatchnormEpsilon", NewTestBatchnormEpsilon)
	testbackend.Register("BatchNormalization", "TestBatchnormExample", NewTestBatchnormExample)
	testbackend.Register("Cast", "TestCastDOUBLEToFLOAT", NewTestCastDOUBLEToFLOAT)
	testbackend.Register("Cast", "TestCastFLOATToDOUBLE", NewTestCastFLOATToDOUBLE)
	testbackend.Register("Ceil", "TestCeil", NewTestCeil)
	testbackend.Register("Ceil", "TestCeilExample", NewTestCeilExample)
	testbackend.Register("Clip", "TestClip", NewTestClip)
	testbackend.Register("Clip", "TestClipDefaultInbounds", NewTestClipDefaultInbounds)
	testbackend.Register("Clip", "TestClipDefaultMax", NewTestClipDefaultMax)
	testbackend.Register("Clip", "TestClipDefaultMin", NewTestClipDefaultMin)
	testbackend.Register("Clip", "TestClipExample", NewTestClipExample)
	testbackend.Register("Clip", "TestClipInbounds", NewTestClipInbounds)
	testbackend.Register("Clip", "TestClipOutbounds", NewTestClipOutbounds)
	testbackend.Register("Clip", "TestClipSplitbounds", NewTestClipSplitbounds)
	testbackend.Register("Concat", "TestConcat1dAxis0", NewTestConcat1dAxis0)
	testbackend.Register("Concat", "TestConcat2dAxis0", NewTestConcat2dAxis0)
	testbackend.Register("Concat", "TestConcat2dAxis1", NewTestConcat2dAxis1)
	testbackend.Register("Concat", "TestConcat3dAxis0", NewTestConcat3dAxis0)
	testbackend.Register("Concat", "TestConcat3dAxis1", NewTestConcat3dAxis1)
	testbackend.Register("Concat", "TestConcat3dAxis2", NewTestConcat3dAxis2)
	testbackend.Register("Constant", "TestConstant", NewTestConstant)
	testbackend.Register("Pad", "TestConstantPad", NewTestConstantPad)
	testbackend.Register("ConstantOfShape", "TestConstantofshapeFloatOnes", NewTestConstantofshapeFloatOnes)
	testbackend.Register("ConstantOfShape", "TestConstantofshapeIntZeros", NewTestConstantofshapeIntZeros)
	testbackend.Register("Conv", "TestConvWithStridesAndAsymmetricPadding", NewTestConvWithStridesAndAsymmetricPadding)
	testbackend.Register("Conv", "TestConvWithStridesNoPadding", NewTestConvWithStridesNoPadding)
	testbackend.Register("Conv", "TestConvWithStridesPadding", NewTestConvWithStridesPadding)
	testbackend.Register("ConvTranspose", "TestConvtranspose", NewTestConvtranspose)
	testbackend.Register("ConvTranspose", "TestConvtranspose1d", NewTestConvtranspose1d)
	testbackend.Register("ConvTranspose", "TestConvtranspose3d", NewTestConvtranspose3d)
	testbackend.Register("ConvTranspose", "TestConvtransposeDilations", NewTestConvtransposeDilations)
	testbackend.Register("ConvTranspose", "TestConvtransposeKernelShape", NewTestConvtransposeKernelShape)
	testbackend.Register("ConvTranspose", "TestConvtransposeOutputShape", NewTestConvtransposeOutputShape)
	testbackend.Register("ConvTranspose", "TestConvtransposePad", NewTestConvtransposePad)
	testbackend.Register("ConvTranspose", "TestConvtransposePads", NewTestConvtransposePads)
	testbackend.Register("ConvTranspose", "TestConvtransposeWithKernel", NewTestConvtransposeWithKernel)
	testbackend.Register("Cos", "TestCos", NewTestCos)
	testbackend.Register("Cos", "TestCosExample", NewTestCosExample)
	testbackend.Register("Cosh", "TestCosh", NewTestCosh)
	testbackend.Register("Cosh", "TestCoshExample", NewTestCoshExample)
	testbackend.Register("DepthToSpace", "TestDepthtospace", NewTestDepthtospace)
	testbackend.Register("DepthToSpace", "TestDepthtospaceExample", NewTestDepthtospaceExample)
	testbackend.Register("Div", "TestDiv", NewTestDiv)
	testbackend.Register("Div", "TestDivBcast", NewTestDivBcast)
	testbackend.Register("Div", "TestDivExample", NewTestDivExample)
	testbackend.Register("Dropout", "TestDropoutDefault", NewTestDropoutDefault)
	testbackend.Register("Dropout", "TestDropoutRandom", NewTestDropoutRandom)
	testbackend.Register("Pad", "TestEdgePad", NewTestEdgePad)
	testbackend.Register("Elu", "TestElu", NewTestElu)
	testbackend.Register("Elu", "TestEluDefault", NewTestEluDefault)
	testbackend.Register("Elu", "TestEluExample", NewTestEluExample)
	testbackend.Register("Erf", "TestErf", NewTestErf)
	testbackend.Register("Exp", "TestExp", NewTestExp)
	testbackend.Register("Exp", "TestExpExample", NewTestExpExample)
	testbackend.Register("Expand", "TestExpandDimChanged", NewTestExpandDimChanged)
	testbackend.Register("Expand", "TestExpandDimUnchanged", NewTestExpandDimUnchanged)
	testbackend.Register("EyeLike", "TestEyelikePopulateOffMainDiagonal", NewTestEyelikePopulateOffMainDiagonal)
	testbackend.Register("EyeLike", "TestEyelikeWithDtype", NewTestEyelikeWithDtype)
	testbackend.Register("EyeLike", "TestEyelikeWithoutDtype", NewTestEyelikeWithoutDtype)
	testbackend.Register("Flatten", "TestFlattenAxis0", NewTestFlattenAxis0)
	testbackend.Register("Flatten", "TestFlattenAxis1", NewTestFlattenAxis1)
	testbackend.Register("Flatten", "TestFlattenAxis2", NewTestFlattenAxis2)
	testbackend.Register("Flatten", "TestFlattenAxis3", NewTestFlattenAxis3)
	testbackend.Register("Flatten", "TestFlattenDefaultAxis", NewTestFlattenDefaultAxis)
	testbackend.Register("Floor", "TestFloor", NewTestFloor)
	testbackend.Register("Floor", "TestFloorExample", NewTestFloorExample)
	testbackend.Register("Gather", "TestGather0", NewTestGather0)
	testbackend.Register("Gather", "TestGather1", NewTestGather1)
	testbackend.Register("Gemm", "TestGemmBroadcast", NewTestGemmBroadcast)
	testbackend.Register("Gemm", "TestGemmNobroadcast", NewTestGemmNobroadcast)
	testbackend.Register("GlobalAveragePool", "TestGlobalaveragepool", NewTestGlobalaveragepool)
	testbackend.Register("GlobalAveragePool", "TestGlobalaveragepoolPrecomputed", NewTestGlobalaveragepoolPrecomputed)
	testbackend.Register("GlobalMaxPool", "TestGlobalmaxpool", NewTestGlobalmaxpool)
	testbackend.Register("GlobalMaxPool", "TestGlobalmaxpoolPrecomputed", NewTestGlobalmaxpoolPrecomputed)
	testbackend.Register("Hardmax", "TestHardmaxAxis0", NewTestHardmaxAxis0)
	testbackend.Register("Hardmax", "TestHardmaxAxis1", NewTestHardmaxAxis1)
	testbackend.Register("Hardmax", "TestHardmaxAxis2", NewTestHardmaxAxis2)
	testbackend.Register("Hardmax", "TestHardmaxDefaultAxis", NewTestHardmaxDefaultAxis)
	testbackend.Register("Hardmax", "TestHardmaxExample", NewTestHardmaxExample)
	testbackend.Register("Hardmax", "TestHardmaxOneHot", NewTestHardmaxOneHot)
	testbackend.Register("HardSigmoid", "TestHardsigmoid", NewTestHardsigmoid)
	testbackend.Register("HardSigmoid", "TestHardsigmoidDefault", NewTestHardsigmoidDefault)
	testbackend.Register("HardSigmoid", "TestHardsigmoidExample", NewTestHardsigmoidExample)
	testbackend.Register("Identity", "TestIdentity", NewTestIdentity)
	testbackend.Register("InstanceNormalization", "TestInstancenormEpsilon", NewTestInstancenormEpsilon)
	testbackend.Register("InstanceNormalization", "TestInstancenormExample", NewTestInstancenormExample)
	testbackend.Register("LeakyRelu", "TestLeakyrelu", NewTestLeakyrelu)
	testbackend.Register("LeakyRelu", "TestLeakyreluDefault", NewTestLeakyreluDefault)
	testbackend.Register("LeakyRelu", "TestLeakyreluExample", NewTestLeakyreluExample)
	testbackend.Register("Log", "TestLog", NewTestLog)
	testbackend.Register("Log", "TestLogExample", NewTestLogExample)
	testbackend.Register("LogSoftmax", "TestLogsoftmaxAxis0", NewTestLogsoftmaxAxis0)
	testbackend.Register("LogSoftmax", "TestLogsoftmaxAxis1", NewTestLogsoftmaxAxis1)
	testbackend.Register("LogSoftmax", "TestLogsoftmaxAxis2", NewTestLogsoftmaxAxis2)
	testbackend.Register("LogSoftmax", "TestLogsoftmaxDefaultAxis", NewTestLogsoftmaxDefaultAxis)
	testbackend.Register("LogSoftmax", "TestLogsoftmaxExample1", NewTestLogsoftmaxExample1)
	testbackend.Register("LogSoftmax", "TestLogsoftmaxLargeNumber", NewTestLogsoftmaxLargeNumber)
	testbackend.Register("LRN", "TestLrn", NewTestLrn)
	testbackend.Register("LRN", "TestLrnDefault", NewTestLrnDefault)
	testbackend.Register("MatMul", "TestMatmul2d", NewTestMatmul2d)
	testbackend.Register("MatMul", "TestMatmul3d", NewTestMatmul3d)
	testbackend.Register("MatMul", "TestMatmul4d", NewTestMatmul4d)
	testbackend.Register("Max", "TestMaxExample", NewTestMaxExample)
	testbackend.Register("Max", "TestMaxOneInput", NewTestMaxOneInput)
	testbackend.Register("Max", "TestMaxTwoInputs", NewTestMaxTwoInputs)
	testbackend.Register("MaxPool", "TestMaxpool1dDefault", NewTestMaxpool1dDefault)
	testbackend.Register("MaxPool", "TestMaxpool2dCeil", NewTestMaxpool2dCeil)
	testbackend.Register("MaxPool", "TestMaxpool2dDefault", NewTestMaxpool2dDefault)
	testbackend.Register("MaxPool", "TestMaxpool2dDilations", NewTestMaxpool2dDilations)
	testbackend.Register("MaxPool", "TestMaxpool2dPads", NewTestMaxpool2dPads)
	testbackend.Register("MaxPool", "TestMaxpool2dPrecomputedPads", NewTestMaxpool2dPrecomputedPads)
	testbackend.Register("MaxPool", "TestMaxpool2dPrecomputedSameUpper", NewTestMaxpool2dPrecomputedSameUpper)
	testbackend.Register("MaxPool", "TestMaxpool2dPrecomputedStrides", NewTestMaxpool2dPrecomputedStrides)
	testbackend.Register("MaxPool", "TestMaxpool2dSameLower", NewTestMaxpool2dSameLower)
	testbackend.Register("MaxPool", "TestMaxpool2dSameUpper", NewTestMaxpool2dSameUpper)
	testbackend.Register("MaxPool", "TestMaxpool2dStrides", NewTestMaxpool2dStrides)
	testbackend.Register("MaxPool", "TestMaxpool3dDefault", NewTestMaxpool3dDefault)
	testbackend.Register("MaxPool", "TestMaxpoolWithArgmax2dPrecomputedPads", NewTestMaxpoolWithArgmax2dPrecomputedPads)
	testbackend.Register("MaxPool", "TestMaxpoolWithArgmax2dPrecomputedStrides", NewTestMaxpoolWithArgmax2dPrecomputedStrides)
	testbackend.Register("MaxUnpool", "TestMaxunpoolExportWithOutputShape", NewTestMaxunpoolExportWithOutputShape)
	testbackend.Register("MaxUnpool", "TestMaxunpoolExportWithoutOutputShape", NewTestMaxunpoolExportWithoutOutputShape)
	testbackend.Register("Mean", "TestMeanExample", NewTestMeanExample)
	testbackend.Register("Mean", "TestMeanOneInput", NewTestMeanOneInput)
	testbackend.Register("Mean", "TestMeanTwoInputs", NewTestMeanTwoInputs)
	testbackend.Register("Min", "TestMinExample", NewTestMinExample)
	testbackend.Register("Min", "TestMinOneInput", NewTestMinOneInput)
	testbackend.Register("Min", "TestMinTwoInputs", NewTestMinTwoInputs)
	testbackend.Register("Mul", "TestMul", NewTestMul)
	testbackend.Register("Mul", "TestMulBcast", NewTestMulBcast)
	testbackend.Register("Mul", "TestMulExample", NewTestMulExample)
	testbackend.Register("MeanVarianceNormalization", "TestMvn", NewTestMvn)
	testbackend.Register("Neg", "TestNeg", NewTestNeg)
	testbackend.Register("Neg", "TestNegExample", NewTestNegExample)
	testbackend.Register("Pow", "TestPow", NewTestPow)
	testbackend.Register("Pow", "TestPowBcastArray", NewTestPowBcastArray)
	testbackend.Register("Pow", "TestPowExample", NewTestPowExample)
	testbackend.Register("PRelu", "TestPreluBroadcast", NewTestPreluBroadcast)
	testbackend.Register("PRelu", "TestPreluExample", NewTestPreluExample)
	testbackend.Register("Reciprocal", "TestReciprocal", NewTestReciprocal)
	testbackend.Register("Reciprocal", "TestReciprocalExample", NewTestReciprocalExample)
	testbackend.Register("ReduceL1", "TestReduceL1DefaultAxesKeepdimsExample", NewTestReduceL1DefaultAxesKeepdimsExample)
	testbackend.Register("ReduceL1", "TestReduceL1DefaultAxesKeepdimsRandom", NewTestReduceL1DefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceL1", "TestReduceL1DoNotKeepdimsExample", NewTestReduceL1DoNotKeepdimsExample)
	testbackend.Register("ReduceL1", "TestReduceL1DoNotKeepdimsRandom", NewTestReduceL1DoNotKeepdimsRandom)
	testbackend.Register("ReduceL1", "TestReduceL1KeepDimsExample", NewTestReduceL1KeepDimsExample)
	testbackend.Register("ReduceL1", "TestReduceL1KeepDimsRandom", NewTestReduceL1KeepDimsRandom)
	testbackend.Register("ReduceL2", "TestReduceL2DefaultAxesKeepdimsExample", NewTestReduceL2DefaultAxesKeepdimsExample)
	testbackend.Register("ReduceL2", "TestReduceL2DefaultAxesKeepdimsRandom", NewTestReduceL2DefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceL2", "TestReduceL2DoNotKeepdimsExample", NewTestReduceL2DoNotKeepdimsExample)
	testbackend.Register("ReduceL2", "TestReduceL2DoNotKeepdimsRandom", NewTestReduceL2DoNotKeepdimsRandom)
	testbackend.Register("ReduceL2", "TestReduceL2KeepDimsExample", NewTestReduceL2KeepDimsExample)
	testbackend.Register("ReduceL2", "TestReduceL2KeepDimsRandom", NewTestReduceL2KeepDimsRandom)
	testbackend.Register("ReduceLogSum", "TestReduceLogSum", NewTestReduceLogSum)
	testbackend.Register("ReduceLogSum", "TestReduceLogSumAscAxes", NewTestReduceLogSumAscAxes)
	testbackend.Register("ReduceLogSum", "TestReduceLogSumDefault", NewTestReduceLogSumDefault)
	testbackend.Register("ReduceLogSum", "TestReduceLogSumDescAxes", NewTestReduceLogSumDescAxes)
	testbackend.Register("ReduceLogSumExp", "TestReduceLogSumExpDefaultAxesKeepdimsExample", NewTestReduceLogSumExpDefaultAxesKeepdimsExample)
	testbackend.Register("ReduceLogSumExp", "TestReduceLogSumExpDefaultAxesKeepdimsRandom", NewTestReduceLogSumExpDefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceLogSumExp", "TestReduceLogSumExpDoNotKeepdimsExample", NewTestReduceLogSumExpDoNotKeepdimsExample)
	testbackend.Register("ReduceLogSumExp", "TestReduceLogSumExpDoNotKeepdimsRandom", NewTestReduceLogSumExpDoNotKeepdimsRandom)
	testbackend.Register("ReduceLogSumExp", "TestReduceLogSumExpKeepdimsExample", NewTestReduceLogSumExpKeepdimsExample)
	testbackend.Register("ReduceLogSumExp", "TestReduceLogSumExpKeepdimsRandom", NewTestReduceLogSumExpKeepdimsRandom)
	testbackend.Register("ReduceMax", "TestReduceMaxDefaultAxesKeepdimExample", NewTestReduceMaxDefaultAxesKeepdimExample)
	testbackend.Register("ReduceMax", "TestReduceMaxDefaultAxesKeepdimsRandom", NewTestReduceMaxDefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceMax", "TestReduceMaxDoNotKeepdimsExample", NewTestReduceMaxDoNotKeepdimsExample)
	testbackend.Register("ReduceMax", "TestReduceMaxDoNotKeepdimsRandom", NewTestReduceMaxDoNotKeepdimsRandom)
	testbackend.Register("ReduceMax", "TestReduceMaxKeepdimsExample", NewTestReduceMaxKeepdimsExample)
	testbackend.Register("ReduceMax", "TestReduceMaxKeepdimsRandom", NewTestReduceMaxKeepdimsRandom)
	testbackend.Register("ReduceMean", "TestReduceMeanDefaultAxesKeepdimsExample", NewTestReduceMeanDefaultAxesKeepdimsExample)
	testbackend.Register("ReduceMean", "TestReduceMeanDefaultAxesKeepdimsRandom", NewTestReduceMeanDefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceMean", "TestReduceMeanDoNotKeepdimsExample", NewTestReduceMeanDoNotKeepdimsExample)
	testbackend.Register("ReduceMean", "TestReduceMeanDoNotKeepdimsRandom", NewTestReduceMeanDoNotKeepdimsRandom)
	testbackend.Register("ReduceMean", "TestReduceMeanKeepdimsExample", NewTestReduceMeanKeepdimsExample)
	testbackend.Register("ReduceMean", "TestReduceMeanKeepdimsRandom", NewTestReduceMeanKeepdimsRandom)
	testbackend.Register("ReduceMin", "TestReduceMinDefaultAxesKeepdimsExample", NewTestReduceMinDefaultAxesKeepdimsExample)
	testbackend.Register("ReduceMin", "TestReduceMinDefaultAxesKeepdimsRandom", NewTestReduceMinDefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceMin", "TestReduceMinDoNotKeepdimsExample", NewTestReduceMinDoNotKeepdimsExample)
	testbackend.Register("ReduceMin", "TestReduceMinDoNotKeepdimsRandom", NewTestReduceMinDoNotKeepdimsRandom)
	testbackend.Register("ReduceMin", "TestReduceMinKeepdimsExample", NewTestReduceMinKeepdimsExample)
	testbackend.Register("ReduceMin", "TestReduceMinKeepdimsRandom", NewTestReduceMinKeepdimsRandom)
	testbackend.Register("ReduceProd", "TestReduceProdDefaultAxesKeepdimsExample", NewTestReduceProdDefaultAxesKeepdimsExample)
	testbackend.Register("ReduceProd", "TestReduceProdDefaultAxesKeepdimsRandom", NewTestReduceProdDefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceProd", "TestReduceProdDoNotKeepdimsExample", NewTestReduceProdDoNotKeepdimsExample)
	testbackend.Register("ReduceProd", "TestReduceProdDoNotKeepdimsRandom", NewTestReduceProdDoNotKeepdimsRandom)
	testbackend.Register("ReduceProd", "TestReduceProdKeepdimsExample", NewTestReduceProdKeepdimsExample)
	testbackend.Register("ReduceProd", "TestReduceProdKeepdimsRandom", NewTestReduceProdKeepdimsRandom)
	testbackend.Register("ReduceSum", "TestReduceSumDefaultAxesKeepdimsExample", NewTestReduceSumDefaultAxesKeepdimsExample)
	testbackend.Register("ReduceSum", "TestReduceSumDefaultAxesKeepdimsRandom", NewTestReduceSumDefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceSum", "TestReduceSumDoNotKeepdimsExample", NewTestReduceSumDoNotKeepdimsExample)
	testbackend.Register("ReduceSum", "TestReduceSumDoNotKeepdimsRandom", NewTestReduceSumDoNotKeepdimsRandom)
	testbackend.Register("ReduceSum", "TestReduceSumKeepdimsExample", NewTestReduceSumKeepdimsExample)
	testbackend.Register("ReduceSum", "TestReduceSumKeepdimsRandom", NewTestReduceSumKeepdimsRandom)
	testbackend.Register("ReduceSumSquare", "TestReduceSumSquareDefaultAxesKeepdimsExample", NewTestReduceSumSquareDefaultAxesKeepdimsExample)
	testbackend.Register("ReduceSumSquare", "TestReduceSumSquareDefaultAxesKeepdimsRandom", NewTestReduceSumSquareDefaultAxesKeepdimsRandom)
	testbackend.Register("ReduceSumSquare", "TestReduceSumSquareDoNotKeepdimsExample", NewTestReduceSumSquareDoNotKeepdimsExample)
	testbackend.Register("ReduceSumSquare", "TestReduceSumSquareDoNotKeepdimsRandom", NewTestReduceSumSquareDoNotKeepdimsRandom)
	testbackend.Register("ReduceSumSquare", "TestReduceSumSquareKeepdimsExample", NewTestReduceSumSquareKeepdimsExample)
	testbackend.Register("ReduceSumSquare", "TestReduceSumSquareKeepdimsRandom", NewTestReduceSumSquareKeepdimsRandom)
	testbackend.Register("Pad", "TestReflectPad", NewTestReflectPad)
	testbackend.Register("Relu", "TestRelu", NewTestRelu)
	testbackend.Register("Reshape", "TestReshapeExtendedDims", NewTestReshapeExtendedDims)
	testbackend.Register("Reshape", "TestReshapeNegativeDim", NewTestReshapeNegativeDim)
	testbackend.Register("Reshape", "TestReshapeReducedDims", NewTestReshapeReducedDims)
	testbackend.Register("Reshape", "TestReshapeReorderedDims", NewTestReshapeReorderedDims)
	testbackend.Register("Resize", "TestResizeDownsampleLinear", NewTestResizeDownsampleLinear)
	testbackend.Register("Resize", "TestResizeDownsampleNearest", NewTestResizeDownsampleNearest)
	testbackend.Register("Resize", "TestResizeNearest", NewTestResizeNearest)
	testbackend.Register("Resize", "TestResizeUpsampleLinear", NewTestResizeUpsampleLinear)
	testbackend.Register("Resize", "TestResizeUpsampleNearest", NewTestResizeUpsampleNearest)
	testbackend.Register("Scan", "TestScan9Sum", NewTestScan9Sum)
	testbackend.Register("Scatter", "TestScatterWithAxis", NewTestScatterWithAxis)
	testbackend.Register("Scatter", "TestScatterWithoutAxis", NewTestScatterWithoutAxis)
	testbackend.Register("Selu", "TestSelu", NewTestSelu)
	testbackend.Register("Selu", "TestSeluDefault", NewTestSeluDefault)
	testbackend.Register("Selu", "TestSeluExample", NewTestSeluExample)
	testbackend.Register("Shape", "TestShape", NewTestShape)
	testbackend.Register("Shape", "TestShapeExample", NewTestShapeExample)
	testbackend.Register("Shrink", "TestShrinkHard", NewTestShrinkHard)
	testbackend.Register("Shrink", "TestShrinkSoft", NewTestShrinkSoft)
	testbackend.Register("Sigmoid", "TestSigmoid", NewTestSigmoid)
	testbackend.Register("Sigmoid", "TestSigmoidExample", NewTestSigmoidExample)
	testbackend.Register("Sign", "TestSign", NewTestSign)
	testbackend.Register("Sin", "TestSin", NewTestSin)
	testbackend.Register("Sin", "TestSinExample", NewTestSinExample)
	testbackend.Register("Sinh", "TestSinh", NewTestSinh)
	testbackend.Register("Sinh", "TestSinhExample", NewTestSinhExample)
	testbackend.Register("Slice", "TestSlice", NewTestSlice)
	testbackend.Register("Slice", "TestSliceDefaultAxes", NewTestSliceDefaultAxes)
	testbackend.Register("Slice", "TestSliceDefaultSteps", NewTestSliceDefaultSteps)
	testbackend.Register("Slice", "TestSliceNegSteps", NewTestSliceNegSteps)

	testbackend.Register("Softmax", "TestSoftmaxAxis0", NewTestSoftmaxAxis0)
	testbackend.Register("Softmax", "TestSoftmaxAxis1", NewTestSoftmaxAxis1)
	testbackend.Register("Softmax", "TestSoftmaxAxis2", NewTestSoftmaxAxis2)
	testbackend.Register("Softmax", "TestSoftmaxDefaultAxis", NewTestSoftmaxDefaultAxis)
	testbackend.Register("Softmax", "TestSoftmaxExample", NewTestSoftmaxExample)
	testbackend.Register("Softmax", "TestSoftmaxLargeNumber", NewTestSoftmaxLargeNumber)
	testbackend.Register("Softplus", "TestSoftplus", NewTestSoftplus)
	testbackend.Register("Softplus", "TestSoftplusExample", NewTestSoftplusExample)
	testbackend.Register("Softsign", "TestSoftsign", NewTestSoftsign)
	testbackend.Register("Softsign", "TestSoftsignExample", NewTestSoftsignExample)
	testbackend.Register("Split", "TestSplitEqualParts1d", NewTestSplitEqualParts1d)
	testbackend.Register("Split", "TestSplitEqualParts2d", NewTestSplitEqualParts2d)
	testbackend.Register("Split", "TestSplitEqualPartsDefaultAxis", NewTestSplitEqualPartsDefaultAxis)
	testbackend.Register("Split", "TestSplitVariableParts1d", NewTestSplitVariableParts1d)
	testbackend.Register("Split", "TestSplitVariableParts2d", NewTestSplitVariableParts2d)
	testbackend.Register("Split", "TestSplitVariablePartsDefaultAxis", NewTestSplitVariablePartsDefaultAxis)
	testbackend.Register("Sqrt", "TestSqrt", NewTestSqrt)
	testbackend.Register("Sqrt", "TestSqrtExample", NewTestSqrtExample)
	testbackend.Register("Squeeze", "TestSqueeze", NewTestSqueeze)
	testbackend.Register("Sub", "TestSub", NewTestSub)
	testbackend.Register("Sub", "TestSubBcast", NewTestSubBcast)
	testbackend.Register("Sub", "TestSubExample", NewTestSubExample)
	testbackend.Register("Sum", "TestSumExample", NewTestSumExample)
	testbackend.Register("Sum", "TestSumOneInput", NewTestSumOneInput)
	testbackend.Register("Sum", "TestSumTwoInputs", NewTestSumTwoInputs)
	testbackend.Register("Tan", "TestTan", NewTestTan)
	testbackend.Register("Tan", "TestTanExample", NewTestTanExample)
	testbackend.Register("Tanh", "TestTanh", NewTestTanh)
	testbackend.Register("Tanh", "TestTanhExample", NewTestTanhExample)
	testbackend.Register("TfIdfVectorizer", "TestTfidfvectorizerTfBatchOnlybigramsSkip0", NewTestTfidfvectorizerTfBatchOnlybigramsSkip0)
	testbackend.Register("TfIdfVectorizer", "TestTfidfvectorizerTfBatchOnlybigramsSkip5", NewTestTfidfvectorizerTfBatchOnlybigramsSkip5)
	testbackend.Register("TfIdfVectorizer", "TestTfidfvectorizerTfBatchUniandbigramsSkip5", NewTestTfidfvectorizerTfBatchUniandbigramsSkip5)
	testbackend.Register("TfIdfVectorizer", "TestTfidfvectorizerTfOnlyBigramsSkip0", NewTestTfidfvectorizerTfOnlyBigramsSkip0)
	testbackend.Register("TfIdfVectorizer", "TestTfidfvectorizerTfOnlybigramsLevelempty", NewTestTfidfvectorizerTfOnlybigramsLevelempty)
	testbackend.Register("TfIdfVectorizer", "TestTfidfvectorizerTfOnlybigramsSkip5", NewTestTfidfvectorizerTfOnlybigramsSkip5)
	testbackend.Register("TfIdfVectorizer", "TestTfidfvectorizerTfUniandbigramsSkip5", NewTestTfidfvectorizerTfUniandbigramsSkip5)
	testbackend.Register("ThresholdedRelu", "TestThresholdedrelu", NewTestThresholdedrelu)
	testbackend.Register("ThresholdedRelu", "TestThresholdedreluDefault", NewTestThresholdedreluDefault)
	testbackend.Register("ThresholdedRelu", "TestThresholdedreluExample", NewTestThresholdedreluExample)
	testbackend.Register("Tile", "TestTile", NewTestTile)
	testbackend.Register("Tile", "TestTilePrecomputed", NewTestTilePrecomputed)
	testbackend.Register("Transpose", "TestTransposeAllPermutations0", NewTestTransposeAllPermutations0)
	testbackend.Register("Transpose", "TestTransposeAllPermutations1", NewTestTransposeAllPermutations1)
	testbackend.Register("Transpose", "TestTransposeAllPermutations2", NewTestTransposeAllPermutations2)
	testbackend.Register("Transpose", "TestTransposeAllPermutations3", NewTestTransposeAllPermutations3)
	testbackend.Register("Transpose", "TestTransposeAllPermutations4", NewTestTransposeAllPermutations4)
	testbackend.Register("Transpose", "TestTransposeAllPermutations5", NewTestTransposeAllPermutations5)
	testbackend.Register("Transpose", "TestTransposeDefault", NewTestTransposeDefault)
	testbackend.Register("Unsqueeze", "TestUnsqueeze", NewTestUnsqueeze)
	testbackend.Register("Upsample", "TestUpsampleNearest", NewTestUpsampleNearest)
}
